Subject: RE: Issues: MKCOL_AND_302, IMPLIED_LWS, PUT_AND_INTERMEDIATE_COLLECTIONS, INTEROP_DELETE_AND_MULTISTATUS

From: "Julian Reschke" <[email-masked]>
Date: Fri, 27 Jun 2003 09:53:01 +0200

Jim,

> It seems to me that it's possible to configure a WebDAV server 
> such that it doesn't support redirect reference resources, but 
> does give out 302s for some URLs. 

I think that's just a matter of what you mean by "support redirect reference resources". If it can return 302s, it knows about redirects. It may not support to *author* them, but that's a separate issue.

> I'm fine with saying MKCOL, like all methods, is redirected by 302.

So what does this mean? If a client does a MKCOL on a URI and receive a 302 with Location header, what is it supposed to do?

a) consider this a failure, just as a 405 (resource exists)
b) redirect the MKCOL to the URI specified in the Location header?

IMHO, the answer must be a), thus the request is not really redirected -- it just fails, because the resource identified by the request URI already exists, and MKCOL is defined only to suceed on null resources.

Julian

--
<green/>bytes GmbH -- http://www.greenbytes.de -- tel:+492512807760

---

From: "Julian Reschke" <[email-masked]>
Date: Fri, 27 Jun 2003 14:13:00 +0200

> From: [email-masked] [mailto:[email-masked]]On
> Behalf Of Geoffrey M Clemm
> Sent: Friday, June 27, 2003 1:37 PM
> To: 'Webdav WG'
> Subject: RE: Issues: MKCOL_AND_302
>
>
>
> Why do you think the answer is "a"?  If the URL to which the
> 302 is redirecting the client is not mapped to a resource,
> a MKCOL to that URL can succeed (privileges permitting), so
> I would conclude that "b" is the correct answer (and therefore,
> MKCOL acts like any other method wrt 302 handling).

But a user agent never would be able to automatically forward the MKCOL to
the target, because MKCOL isn't a safe method, right?

Julian

---

From: Geoffrey M Clemm <[email-masked]>
Date: Fri, 27 Jun 2003 07:36:32 -0400

Cheers,
Geoff

Julian wrote on 06/27/2003 03:53:01 AM:

> I think that's just a matter of what you mean by "support redirect 
> reference resources". If it can return 302s, it knows about 
> redirects. It may not support to *author* them, but that's a separate 
issue.
> So what does this mean? If a client does a MKCOL on a URI and 
> receive a 302 with Location header, what is it supposed to do?
> 
> IMHO, the answer must be a), thus the request is not really 
> redirected -- it just fails, because the resource identified by the 
> request URI already exists, and MKCOL is defined only to suceed on 
> null resources.
> 
> Julian
> 
> --

---

From: Geoffrey M Clemm <[email-masked]>
Date: Fri, 27 Jun 2003 08:53:44 -0400

Yes, a user agent should ask for user confirmation before doing the
forwarding, but that is standard 302 handling for a method
that is not safe (i.e. MKCOL is no different from PUT, DELETE, etc. in
this regard). So MKCOL should acts as is defined by section 10.3.3
of RFC-2616, so I don't see why it needs to have anything special said
about it wrt 302 handling.

Cheers,
Geoff